VERSION 0.8 # https://docs.earthly.dev/docs/earthfile#version
FROM python:3

ARG --global build_dir="dist"


################
# Main targets #
################

{% include "./fragments/node.earth" %}

# Build the site
build:
    ARG yama_env="production"

    FROM +node-base
    WORKDIR /workdir
    CACHE .nuxt
    CACHE .node_modules/.vite
    CACHE .node_modules/.cache

    COPY . .

    # Uncomment if you wish to disable nuxtjs telemetry. Learn more at https://nuxtjs.org/docs/configuration-glossary/configuration-telemetry/
    #ENV NUXT_TELEMETRY_DISABLED=1
    ENV NODE_OPTIONS="--max-old-space-size=8192"
    ENV YAMA_ENV=$yama_env

    # assumes you have scripts in your package.json to run "next build" and "next export"
    RUN yarn run generate --fail-on-error

    SAVE ARTIFACT $build_dir build_result AS LOCAL $build_dir




##################
# Helper targets #
##################

{% include "./fragments/node-helpers.earth" %}

# Run `nuxt dev` dev server with $PWD mounted. Run locally with `earthly +dev`.
# Note that if you exit Earthly (eg. via Ctrl+c), Earthly will immediately exit and leave the container running.
# You can manually stop it with `earthly +stop-dev` (or `docker stop earthly-dev-server`).
dev:
    ARG port=3000
    ARG container_name="earthly-dev-server"
    LOCALLY
        WITH DOCKER --load earthly-dev-server-image=+node-base
            RUN docker run --rm -i \
                        --volume="$PWD":/workdir:Z \
                        --env HOST=0.0.0.0 \
                        --publish $port:3000 \
                        --name="$container_name" \
                        earthly-dev-server-image \
                        yarn run dev
        END

stop-dev:
    ARG container_name="earthly-dev-server"

    LOCALLY
        RUN docker stop "$container_name"




################
# Swift upload #
################

{% include "./fragments/swift.earth" %}
